<?
# Only validate a client if both tokens are present
if (isset($_GET['url_token']) && isset($_COOKIE['cookie_token']))
{
	# Assume identity is valid until proven otherwise
	$identity_validated = 1;

	# Parse cookie token into id, ts, and ua
	$cookie_token_pairs = explode('&', $_COOKIE['cookie_token']);
	foreach ($cookie_token_pairs as $curr_pair)
	{
		list($curr_name, $curr_value) = explode('=', $curr_pair);
		$parsed_cookie["$curr_name"] = $curr_value;
	}

	# Make sure the URL token is the MD5 of the client's ID
	$url_token_should_be = md5($parsed_cookie['id']);
	if ($_GET['url_token'] != $url_token_should_be)
	{
		$identity_validated = 0;
	}

	# Make sure the user agent is correct
	$ua_should_be = urldecode($parsed_cookie['ua']);
	if ($_SERVER['HTTP_USER_AGENT'] != $ua_should_be)
	{
		$identity_validated = 0;
	}

	if ($identity_validated)
	{
		# Update tokens
		$id = $parsed_cookie['id'];
		$ts = gmmktime();
		$ua = urlencode($_SERVER['HTTP_USER_AGENT']);
		$cookie_token = "id=$id&ts=$ts&ua=$ua";
		$url_token = $_GET['url_token'];

		# Update the cookie
		header("Set-Cookie: cookie_token=$cookie_token");

		# Calculate the elapsed time in seconds
		$curr_ts = gmmktime();
		$elapsed_time = $curr_ts - $parsed_cookie['ts'];

		# Display welcome message
		?>
		<p>Welcome back, client [<? echo $parsed_cookie['id']; ?>]</p>
		<p>It has been [<? echo $elapsed_time; ?>] seconds since your last visit</p>
		<p><a href="state_example.php?url_token=<? echo $url_token; ?>">Click Here</a></p>
		<?
	}
}
else
{
	$identity_validated = 0;
}

if (!$identity_validated)
{
	# Create tokens
	$id = uniqid('');
	$ts = gmmktime();
	$ua = urlencode($_SERVER['HTTP_USER_AGENT']);
	$cookie_token = "id=$id&ts=$ts&ua=$ua";
	$url_token = md5($id);

	# Set the cookie
	header("Set-Cookie: cookie_token=$cookie_token");

	# Display welcome message
	?>
	<p>Welcome, new client [<? echo $id; ?>]</p>
	<p><a href="state_example.php?url_token=<? echo $url_token; ?>">Click Here</a></p>
	<?
}
?>
