<?
# Only validate a client if both tokens are present
if (isset($_GET['url_token']) && isset($_COOKIE['cookie_token']))
{
	# Assume identity is valid until proven otherwise
	$identity_validated = 1;

	# Parse cookie token
	$cookie_token_pairs = explode('&', $_COOKIE['cookie_token']);
	foreach ($cookie_token_pairs as $curr_pair)
	{
		list($curr_name, $curr_value) = explode('=', $curr_pair);
		$parsed_cookie["$curr_name"] = $curr_value;
	}

	# Make sure the URL token is the MD5 of the client's ID
	$url_token_should_be = md5($parsed_cookie['id']);
	if ($_GET['url_token'] != $url_token_should_be)
	{
		$identity_validated = 0;
	}

	# Make sure the user agent is correct
	$ua_should_be = urldecode($parsed_cookie['ua']);
	if ($_SERVER['HTTP_USER_AGENT'] != $ua_should_be)
	{
		$identity_validated = 0;
	}

	if ($identity_validated)
	{
		if (isset($_POST['first_name']) && isset($_POST['last_name']))
		{
			# Retrieve last access timestamp
			$id = $parsed_cookie['id'];
			$session_data_store = query("select last_access from session_data_store where unique_id='$id'");
			$last_access = $session_data_store['last_access'];

			# This data should actually be validated first
			$session_data['first_name'] = $_POST['first_name'];
			$session_data['last_name'] = $_POST['last_name'];

			# Update the session data store
			$data = serialize($session_data);
			$curr_ts = gmmktime();
			query("update session_data_store set session_data='$data' where unique_id='$id'");
			query("update session_data_store set last_access='$curr_ts' where unique_id='$id'");
		}
		else
		{
			# Retrieve session data
			$id = $parsed_cookie['id'];
			$session_data_store = query("select * from session_data_store where unique_id='$id'");
			$unique_id = $session_data_store['unique_id'];
			$last_access = $session_data_store['last_access'];
			$session_data = unserialize($session_data_store['session_data']);

			# Update the session data store
			$curr_ts = gmmktime();
			query("update session_data_store set last_access='$curr_ts' where unique_id='$id'");
		}

		# Update tokens
		$ua = urlencode($_SERVER['HTTP_USER_AGENT']);
		$cookie_token = "id=$id&ua=$ua";
		$url_token = $_GET['url_token'];

		# Update the cookie
		header("Set-Cookie: cookie_token=$cookie_token");

		# Calculate the elapsed time in seconds
		$curr_ts = gmmktime();
		$elapsed_time = $curr_ts - $last_access;

		# Display welcome message
		?>
		<p>
		Welcome back,
		[<? echo $session_data['first_name'] . ' ' . $session_data['last_name']; ?>]
		</p>
		<p>It has been [<? echo $elapsed_time; ?>] seconds since your last visit</p>
		<p>
		<a href="session_example.php?url_token=<? echo $url_token; ?>">Click Here</a>
		</p>
		<?
	}
}
else
{
	$identity_validated = 0;
}

if (!$identity_validated)
{
	# Create tokens
	$id = uniqid('');
	$ts = gmmktime();
	$ua = urlencode($_SERVER['HTTP_USER_AGENT']);
	$cookie_token = "id=$id&ua=$ua";
	$url_token = md5($id);

	# Set the cookie
	header("Set-Cookie: cookie_token=$cookie_token");

	# Create a record in the session data store
	query("insert into session_data_store values('$id', '$ts', '')");

	# Display welcome message
	?>
	<p>Welcome, new client [<? echo $id; ?>]</p>
	<p>Please provide your name below</p>
	<form action="session_example.php?url_token=<? echo $url_token; ?>" method="post">
	<p>First Name: <input type="text" name="first_name"></p>
	<p>Last Name: <input type="text" name="last_name"></p>
	<p><input type="submit"></p>
	<?
}

function query($sql)
{
	mysql_connect('localhost', 'myuser', 'mypass');
	mysql_select_db('http');
	$result = mysql_query($sql);
	mysql_close();
	return @mysql_fetch_array($result);
}
?>
